
/*
 * SearchWindow.java
 *
 * Created on 2010-03-22, 16:39:05
 *
 * Autor: Sebastian Sieczko
 * Grupa: PKiSI
 * Nr albumu: 66650
 */
package JDiskCat;

import java.awt.Desktop;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.util.*;
import java.util.logging.*;
import java.io.*;
import javax.swing.*;
import javax.swing.table.DefaultTableModel;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.*;
import org.xml.sax.SAXException;

/**
 *
 * @author sebe
 */
public class SearchWindow extends javax.swing.JFrame {

    private String selected; //wybrany dysk
    private DefaultTableModel tableModel;
    private Vector columns;
    private Vector data;
    private DocumentBuilder loader;
    private Document document;
    private Node root; //węzeł główny
    private String pattern; //szukana fraza
    private Boolean allDisks = false; //czy przeszukiwać wszystkie dyski
    private Vector diskList; //lista dysków

    public SearchWindow() {
        initComponents();
        columns = new Vector(3);
        columns.add("Name");
        columns.add("Size");
        columns.add("Date");
        columns.add("Volume");
        columns.add("Location");
        tableModel = new DefaultTableModel();
        jTable1.setModel(tableModel);
        buttonGroup1.add(jRadioButton1);
        buttonGroup1.add(jRadioButton2);
        diskList = new Vector();
        refreshDiskList();


    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPopupMenu1 = new javax.swing.JPopupMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        jTextField1 = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jComboBox1 = new javax.swing.JComboBox();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jSeparator2 = new javax.swing.JSeparator();
        jRadioButton1 = new javax.swing.JRadioButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jButton2 = new javax.swing.JButton();

        jPopupMenu1.setEnabled(false);

        jMenuItem1.setText("Open");
        jMenuItem1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jMenuItem1MouseReleased(evt);
            }
        });
        jPopupMenu1.add(jMenuItem1);

        jMenuItem2.setText("Open containing folder");
        jMenuItem2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jMenuItem2MouseReleased(evt);
            }
        });
        jPopupMenu1.add(jMenuItem2);

        setTitle("Search");

        jTextField1.setToolTipText("Poszukiwana fraza powinna zawierać przynajmniej 2 znaki. Wielkość liter nie jest rozróżniana przy wyszukiwaniu.");
        jTextField1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField1KeyReleased(evt);
            }
        });

        jLabel1.setText("Search phrase");

        jButton1.setText("Search");
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jButton1MouseReleased(evt);
            }
        });
        jButton1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jButton1KeyReleased(evt);
            }
        });

        jScrollPane2.setAutoscrolls(true);
        jScrollPane2.setDoubleBuffered(true);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null}
            },
            new String [] {
                "Nazwa", "Wielkość", "Data"
            }
        ));
        jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_NEXT_COLUMN);
        jTable1.setComponentPopupMenu(jPopupMenu1);
        jTable1.setDoubleBuffered(true);
        jTable1.setEditingColumn(0);
        jTable1.setEditingRow(0);
        jTable1.setFillsViewportHeight(true);
        jTable1.setFocusable(false);
        jTable1.setGridColor(new java.awt.Color(255, 255, 255));
        jTable1.setIntercellSpacing(new java.awt.Dimension(0, 0));
        jTable1.setShowHorizontalLines(false);
        jTable1.setShowVerticalLines(false);
        jTable1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jTable1MousePressed(evt);
            }
        });
        jScrollPane2.setViewportView(jTable1);

        jSeparator1.setToolTipText("");

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel2.setText("Search options");

        jLabel3.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel3.setText("Volume selection");

        jSeparator2.setToolTipText("");

        jRadioButton1.setSelected(true);
        jRadioButton1.setText("Selected volume");
        jRadioButton1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jRadioButton1StateChanged(evt);
            }
        });

        jRadioButton2.setText("All volumes");

        jButton2.setText("Close");
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jButton2MouseReleased(evt);
            }
        });
        jButton2.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jButton2KeyReleased(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 749, Short.MAX_VALUE)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addGroup(layout.createSequentialGroup()
                            .addComponent(jLabel3)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jSeparator2))
                        .addGroup(layout.createSequentialGroup()
                            .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(layout.createSequentialGroup()
                            .addComponent(jLabel2)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 245, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                .addComponent(jRadioButton1, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)
                                .addComponent(jRadioButton2, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE))
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                .addComponent(jComboBox1, 0, 150, Short.MAX_VALUE)
                                .addComponent(jButton2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                        .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel3)
                    .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton1)
                    .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jRadioButton2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(jButton2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 369, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jTextField1KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField1KeyReleased
        if (evt.getKeyCode() == KeyEvent.VK_ENTER) {
            prepareSearch();
        }
    }//GEN-LAST:event_jTextField1KeyReleased

    private void jButton2MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton2MouseReleased
        this.setVisible(false);
    }//GEN-LAST:event_jButton2MouseReleased

    private void jRadioButton1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jRadioButton1StateChanged
        if (jRadioButton1.isSelected()) {
            allDisks = false;
            jComboBox1.setEnabled(true);
        } else {
            allDisks = true;
            jComboBox1.setEnabled(false);
        }
    }//GEN-LAST:event_jRadioButton1StateChanged

    private void jButton2KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jButton2KeyReleased
        if (evt.getKeyCode() == KeyEvent.VK_ENTER) {
            this.setVisible(false);
        }
    }//GEN-LAST:event_jButton2KeyReleased

    private void jButton1KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jButton1KeyReleased
        if (evt.getKeyCode() == KeyEvent.VK_ENTER) {
            prepareSearch();
        }
    }//GEN-LAST:event_jButton1KeyReleased

    private void jButton1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton1MouseReleased
        prepareSearch();
    }//GEN-LAST:event_jButton1MouseReleased

    private void jMenuItem1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuItem1MouseReleased
        // Menu kontekstowe - otwórz w skojarz. aplikacji
        int row = jTable1.getSelectedRow();
        System.out.println(row);
        if (row != -1 && jTable1.getValueAt(row, 1).toString().length() > 1) {
            try {
                //path z xml np. C:\test zamiant selected w path + \ + nazwa pliku
                //lub path z xml np. C:\ zamiast (selected\) w path + \ +nazwa pliku
                document = loader.parse(jTable1.getValueAt(row, 3).toString() + ".xml");
                root = document.getLastChild();
                Element rootElement = (Element) root;
                String rootPath = rootElement.getAttribute("path");
                String filePath;
                if (rootPath.trim().length() == 3) {
                    filePath = (String) jTable1.getValueAt(row, 4);
                    filePath = rootPath + filePath.substring(1) + "\\" + (String) jTable1.getValueAt(row, 0);
                } else {
                    filePath = (String) jTable1.getValueAt(row, 4);
                    if (filePath.equals("\\")) {
                        filePath = "";
                    }
                    filePath = rootPath + filePath + "\\" + (String) jTable1.getValueAt(row, 0);
                }
                if (filePath.indexOf("/") != -1) {
                    filePath = filePath.replace('\\', '/');
                }
                System.out.println(filePath);
                File file = new File(filePath);
                if (file.exists()) {
                    Desktop desktop;
                    if (Desktop.isDesktopSupported()) {
                        desktop = Desktop.getDesktop();
                        try {
                            desktop.open(file);
                        } catch (IOException ex) {
                            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
                            JOptionPane.showMessageDialog(this, "An error occurred while opening the file. Most likely, no application is associated with that file type.", "Error opening the file.", JOptionPane.ERROR_MESSAGE);
                        }
                    }
                } else {
                    JOptionPane.showMessageDialog(this, "The requested item is not available. Check availability of the volume: \"" + selected + "\".", "Error", JOptionPane.ERROR_MESSAGE);
                }
            } catch (SAXException ex) {
                Logger.getLogger(SearchWindow.class.getName()).log(Level.SEVERE, null, ex);
            } catch (IOException ex) {
                Logger.getLogger(SearchWindow.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

    }//GEN-LAST:event_jMenuItem1MouseReleased

    private void jMenuItem2MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuItem2MouseReleased
        // Menu kontekstowe - otwórz folder zawierający
        int row = jTable1.getSelectedRow();
        if (row != -1 && jTable1.getValueAt(row, 1).toString().length() > 1) {
            try {
                //path z xml np. C:\test zamiant selected w path + \ + nazwa pliku
                //lub path z xml np. C:\ zamiast (selected\) w path + \ +nazwa pliku
                document = loader.parse(jTable1.getValueAt(row, 3).toString() + ".xml");
                root = document.getLastChild();
                Element rootElement = (Element) root;
                String rootPath = rootElement.getAttribute("path");
                String filePath;
                if (rootPath.trim().length() == 3) {
                    filePath = (String) jTable1.getValueAt(row, 4);
                    filePath = rootPath + filePath.substring(1);
                } else {
                    filePath = (String) jTable1.getValueAt(row, 4);
                    if (filePath.equals("\\")) {
                        filePath = "";
                    }
                    filePath = rootPath + filePath;
                }
                if (filePath.indexOf("/") != -1) {
                    filePath = filePath.replace('\\', '/');
                }
                System.out.println(filePath);
                File file = new File(filePath);
                if (file.exists()) {
                    Desktop desktop;
                    if (Desktop.isDesktopSupported()) {
                        desktop = Desktop.getDesktop();
                        try {
                            desktop.open(file);
                        } catch (IOException ex) {
                            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
                            JOptionPane.showMessageDialog(this, "An error occurred while opening the folder.", "Error opening folder.", JOptionPane.ERROR_MESSAGE);
                        }
                    }
                } else {
                    JOptionPane.showMessageDialog(this, "The requested folder is not available. Check availability of the volume: \"" + selected + "\".", "Error opening folder.", JOptionPane.ERROR_MESSAGE);
                }
            } catch (SAXException ex) {
                Logger.getLogger(SearchWindow.class.getName()).log(Level.SEVERE, null, ex);
            } catch (IOException ex) {
                Logger.getLogger(SearchWindow.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }//GEN-LAST:event_jMenuItem2MouseReleased

    private void jTable1MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MousePressed
        Point p = evt.getPoint();
        int row = jTable1.rowAtPoint(p);
        if (row != -1 && !jTable1.getValueAt(row, 0).toString().equals("No results")) {
            ListSelectionModel model = jTable1.getSelectionModel();
            model.setSelectionInterval(row, row);
            jTable1.setComponentPopupMenu(jPopupMenu1);
        } else {
            ListSelectionModel model = jTable1.getSelectionModel();
            model.clearSelection();
            jTable1.setComponentPopupMenu(null);
        }

    }//GEN-LAST:event_jTable1MousePressed

    private void readDisk(String filename) {
        try {
            document = loader.parse(filename);
            root = document.getLastChild();
            search(root, "\\");
        } catch (SAXException ex) {
            Logger.getLogger(SearchWindow.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(SearchWindow.class.getName()).log(Level.SEVERE, null, ex);
        }


    }

    private void search(Node dir, String path) {
        NodeList list = dir.getChildNodes();

        Vector row;
        row = new Vector(3);
        for (int i = 0; i < list.getLength(); i++) {
            Node node = list.item(i);
            row = new Vector(3);
            if (node instanceof Element) {
                Element child = (Element) node;
                String attribName = child.getAttribute("name");
                String attribDate = child.getAttribute("date");
                String attribSize = child.getAttribute("size");

                if (attribSize.isEmpty()) {
                    attribSize = "<DIR>";
                }
                
                row.add(attribName);
                row.add(attribSize);
                row.add(attribDate);
                row.add(selected);
                row.add(path);
                if (attribName.toLowerCase().indexOf(pattern.toLowerCase()) != -1) {
                    data.add(row);
                }
                if (attribSize.equals("<DIR>")) {
                    if (path.equals("\\")) {
                        search(node, path + attribName);
                    } else {
                        search(node, path + "\\" + attribName);
                    }
                }
            }
        }

    }

    private void refreshDiskList() {
        jComboBox1.removeAllItems();
        File dir = new File("."); //kat. programu

        FilenameFilter filter = new FilenameFilter() {

            public boolean accept(File dir, String name) {
                return name.endsWith(".xml") || name.endsWith(".XML");
            }
        };

        File[] chld = dir.listFiles(filter);

        if (chld == null) {
            System.out.println("The selected directory does not exist or is not a directory.");
        } else {
            for (int i = 0; i < chld.length; i++) {
                if (chld[i].isFile() && !chld[i].getName().equals("build.xml") && chld[i].length() > 0) {
                    String name = Main.getFileNameWithoutExtension(chld[i].getName());
                    jComboBox1.addItem(name);
                    diskList.add(name);
                }

            }
        }

        if (Main.getSelectedIndex() != -1) {
            for (int i = 0; i < jComboBox1.getItemCount(); i++) {
                if (jComboBox1.getItemAt(i).toString().equals(Main.getSelected())) {
                    jComboBox1.setSelectedIndex(i);
                }
            }
        }
    }

    private void prepareSearch() {
        selected = jComboBox1.getSelectedItem().toString();
        pattern = jTextField1.getText().trim();
        jTextField1.setText(pattern);
        if (selected != null && !selected.isEmpty() && !pattern.isEmpty() && pattern.length() > 1) {
            try {
                data = new Vector(3);
                DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
                loader = factory.newDocumentBuilder();
                if (!allDisks) {
                    readDisk(selected + ".xml");
                } else {
                    for (int i = 0; i < diskList.size(); i++) {
                        selected = diskList.get(i).toString();
                        readDisk(selected + ".xml");
                    }
                }
                if (data.isEmpty()) {
                    Vector row;
                    row = new Vector(3);
                    row.add("No results");
                    data.add(row);
                }

                tableModel = new javax.swing.table.DefaultTableModel(data, columns);
                jTable1.setModel(tableModel);
            } catch (ParserConfigurationException ex) {
                Logger.getLogger(SearchWindow.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new SearchWindow().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private static javax.swing.JTable jTable1;
    private javax.swing.JTextField jTextField1;
    // End of variables declaration//GEN-END:variables
}
